import { MessageSubscribe, MessageError, MessageData, MessageNotification, MessageUnsubscribe, MessageComplete, MessageOrMessageBatch } from './types';
import { Observable } from 'rxjs';
declare type IncomingMessage = MessageOrMessageBatch<MessageSubscribe | MessageUnsubscribe | MessageNotification>;
declare type OutgoingMessage = MessageOrMessageBatch<MessageData | MessageComplete | MessageError>;
export interface JsonRxServerParams<Ctx = unknown> {
    send: (message: OutgoingMessage) => void;
    call: (name: string, payload: unknown, ctx: Ctx) => Promise<unknown> | Observable<unknown> | Promise<Observable<unknown>>;
    notify: (name: string, payload: unknown, ctx: Ctx) => void;
    maxActiveSubscriptions?: number;
}
export declare class JsonRxServer<Ctx = unknown> {
    private send;
    private call;
    private notify;
    private readonly active;
    private readonly maxActiveSubscriptions;
    constructor({ send, call, notify, maxActiveSubscriptions }: JsonRxServerParams<Ctx>);
    private sendError;
    private onSubscribe;
    private onUnsubscribe;
    private onNotification;
    onMessage(message: IncomingMessage, ctx: Ctx): void;
    stop(): void;
}
export {};
